// -*- mode:c; tab-width:8; c-basic-offset:8; indent-tabs-mode:t -*-
// vim: ts=8 sw=8 smarttab
#ifndef __GRAID_MPMC_QUEUE_INCLUDED__
#define __GRAID_MPMC_QUEUE_INCLUDED__

#include <linux/atomic.h>
#include <stddef.h>

typedef struct {
	atomic64_t seq;
	uint64_t   val;
} mpmc_queue_cell_t;

typedef char mpmc_cacheline_pad_t[64 - 8];

typedef struct {
	size_t cell_mask;
	mpmc_cacheline_pad_t __pad0;
	atomic64_t enqueue_pos;
	mpmc_cacheline_pad_t __pad1;
	atomic64_t dequeue_pos;
	mpmc_cacheline_pad_t __pad2;
	mpmc_queue_cell_t cells[0];
} mpmc_queue_t;

extern mpmc_queue_t *mpmc_queue_alloc(size_t items);
extern void mpmc_queue_free(mpmc_queue_t *queue);
extern bool mpmc_enqueue(mpmc_queue_t *queue, uint64_t val);
extern bool mpmc_dequeue(mpmc_queue_t *queue, uint64_t *val);

#endif
